public class App {

    public static void main(String[] args) {

        System.out.println(summe(1, 5));
        System.out.println(summeRecursive(1, 5));

        System.out.println(indexOf('S', "HAUS"));
        System.out.println(indexOf('K', "HAUS"));
        System.out.println(indexOfRecursive('S', "HAUS"));
        System.out.println(indexOfRecursive('K', "HAUS"));

        System.out.println(factorial(6));
        System.out.println(factorialRecursive(6));
        // Ausnahme: StackOverflowException
        // System.out.println(factorialRecursive(Integer.MAX_VALUE));
    }

    public static int indexOf(char c, String s) {
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) == c)
                return i;
        }
        return -1;
    }

    public static int indexOfRecursive(char c, String s) {
        return indexOfRecursive(c, s, 0);
    }

    private static int indexOfRecursive(char c, String s, int i) {
        if (i >= s.length())
            return -1;

        if (s.charAt(i) == c)
            return i;

        return indexOfRecursive(c, s, ++i);
    }

    public static int summe(int min, int max) {
        int ergebnis = 0;

        while (min <= max) {
            ergebnis += min;
            min++;
        }
        return ergebnis;
    }

    public static int summeRecursive(int min, int max) {
        return summeRecursive(min, max, 0);
    }

    private static int summeRecursive(int min, int max, int ergebnis) {
        if (min > max)
            return ergebnis;

        ergebnis += min;
        min++;
        return summeRecursive(min, max, ergebnis);
    }

    public static int factorial(int n) {
        int result = 1;

        for (int i = 1; i <= n; i++)
            result *= i;

        return result;
    }

    public static int factorialRecursive(int n) {
        if (n == 0)
            return 1;

        return n * factorialRecursive(n - 1);
    }
}