public class App {
    public static void main(String[] args) {

        ColoredGraph<String> graph = new ColoredGraph<>();

        Node<String> a = graph.addNode("A");
        Node<String> b = graph.addNode("B");
        Node<String> c = graph.addNode("C");
        Node<String> e = graph.addNode("E"); // E vertauschen mit D, dann enthält D noch keine Farbe und es wird eine
                                             // mehr benutzt
        Node<String> d = graph.addNode("D");

        graph.addEdge(a, b);
        graph.addEdge(a, c);
        graph.addEdge(b, c);
        graph.addEdge(b, d);
        graph.addEdge(c, d);
        graph.addEdge(d, e);

        String[] colors = { "Rot", "Blau", "Gelb", "Grün" };

        System.out.println("Greedy");
        graph.greedyColoring();
        for (Node<String> n : graph.getNodes()) {
            Integer color = (Integer) n.getColor();
            System.out.println(n.getItem() + ": " + color + " (" + colors[color] + ")");
        }

        System.out.println("Welsh Powell");
        graph.welshPowellColoring();
        for (Node<String> n : graph.getNodes()) {
            Integer color = (Integer) n.getColor();
            System.out.println(n.getItem() + ": " + color + " (" + colors[color] + ")");
        }

        System.out.println("Backtracking");
        graph.backtrackingColoring();
        for (Node<String> n : graph.getNodes()) {
            Integer color = (Integer) n.getColor();
            System.out.println(n.getItem() + ": " + color + " (" + colors[color] + ")");
        }

        String dot = graph.generateDotRepresentation();
        System.out.println("\nDOT Language:\n" + dot);
    }
}
