
public class App {
    public static void main(String[] args) {

        ColoredGraph<String> graph = new ColoredGraph<>();

        var prog = graph.addNode("Programmieren | 3 | Lea  ");
        var algo = graph.addNode("Algorithmik   | 3 | Finn ");
        var db = graph.addNode("Datenbanken   | 1 | Tarek");
        var gr = graph.addNode("Grundlagen    | 1 | Lea  ");
        var ki = graph.addNode("KI            | 1 | Tarek");
        var net = graph.addNode("Netzwerke     | 1 | Lea  ");

        // 3. Semester
        graph.addEdge(prog, algo);

        // 1. Semester
        graph.addEdge(db, gr);
        graph.addEdge(db, ki);
        graph.addEdge(db, net);
        graph.addEdge(gr, ki);
        graph.addEdge(gr, net);
        graph.addEdge(ki, net);

        // Lea
        graph.addEdge(prog, gr);
        graph.addEdge(prog, net);

        // Tarek (bereits durch 1. Semester abgedeckt)
        graph.addEdge(db, ki);

        graph.backtrackingColoring();

        String[] zeiten = { " 8:00 -  9:45",
                "10:00 - 11:30",
                "12:15 - 13:45",
                "14:00 - 15:30" };

        for (Node<String> n : graph.getNodes()) {
            Integer color = (Integer) n.getColor();
            System.out.println(n.getItem() + " -> " + zeiten[color] + "(" + color + ")");
        }

        String s = graph.generateDotRepresentation();
        System.out.println(s);
    }
}
