import java.util.ArrayList;

public class SortedArrayList<T extends Comparable<T>> extends ArrayList<T> {

    public int binarySearch(T item) {
        int lower = 0;
        int upper = size() - 1;

        while (lower <= upper) {
            int mid = (lower + upper) / 2; // alternativ: >> 1 anstatt / 2

            int c = item.compareTo(get(mid));

            if (c == 0)
                return mid;
            else if (c > 0)
                lower = mid + 1; // oben weitersuchen
            else
                upper = mid - 1; // unten weitersuchen
        }

        return ~lower;
    }

    public int binarySearchRecursive(T item) {
        return search(item, 0, size() - 1);
    }

    private int search(T item, int lower, int upper) {

        if (lower > upper)
            return ~lower;

        int mid = (lower + upper) / 2;

        int c = item.compareTo(get(mid));

        if (c == 0)
            return mid;
        else if (c > 0)
            return search(item, mid + 1, upper); // oben weitersuchen
        else
            return search(item, lower, mid - 1); // unten weitersuchen
    }
}
