import java.io.BufferedReader;
import java.io.FileReader;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;

public class App {
    public static void main(String[] args) throws Exception {
        String RESET = "\u001B[0m";
        String RED = "\u001B[31m";
        String GREEN = "\u001B[32m";

        try (BufferedReader dictionary = new BufferedReader(new FileReader(args[1], Charset.forName("UTF-8")))) {

            Spelling spelling = new Spelling(dictionary);

            String text = Files.readString(Paths.get(args[0]), Charset.forName("UTF-8"));

            for (Spelling.Word word : spelling.checkText(text)) {
                if (!word.isCorrect()) {
                    System.out.print(RED + word + " " + RESET);
                    if (word.nearToWord() != null) {
                        System.out.print(GREEN + "(" + word.nearToWord() + ") " + RESET);
                    }
                } else {
                    System.out.print(word + " ");
                }
            }
        }
    }
}
